package org.jboss.support.ws.phonebook;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.jws.WebService;

import org.apache.log4j.Logger;
import org.jboss.ejb3.annotation.SecurityDomain;
//import org.jboss.ws.annotation.EndpointConfig;

@SecurityDomain("JBossWS")
//@EndpointConfig(configName="Standard WSSecurity Endpoint")

@Stateless
@WebService(serviceName = "PhoneBook", endpointInterface = "org.jboss.support.ws.phonebook.PhoneBook", targetNamespace = "http://www.jboss.org/support/phonebook")
public class PhoneBookImpl implements PhoneBook
{

   private static final Logger log = Logger.getLogger(PhoneBookImpl.class);

   @RolesAllowed("friend")
   public TelephoneNumber lookup(Person person) 
   {
      log.info("lookup '" + person.getSurname() + ", " + person.getFirstName() + "'.");

      TelephoneNumber tn = new TelephoneNumber();
      tn.setAreaCode("01234");
      tn.setNumber("567890");

      return tn;
   }

}
