package org.jboss.support.ws.phonebook;

import java.io.IOException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import org.apache.log4j.Logger;
import org.apache.ws.security.WSPasswordCallback;
import org.jboss.security.SecurityAssociation;
import org.jboss.security.SimplePrincipal;

public class ServerCallbackHandler implements CallbackHandler
{
   
   private static final Logger log = Logger.getLogger(ServerCallbackHandler.class);

   public void handle(Callback[] callbacks) throws IOException, UnsupportedCallbackException
   {      
      boolean handled = false;
      for (Callback current : callbacks)
      {
         if (current instanceof WSPasswordCallback == false)
         {
            throw new UnsupportedCallbackException(current);
         } else if (handled==true) {
            throw new IOException("Multiple WSPasswordCallbacks in list of callbacks.");
         } else {
            handled = true;
            WSPasswordCallback pc = (WSPasswordCallback) current;
            SecurityAssociation.setPrincipal(new SimplePrincipal(pc.getIdentifer()));
            SecurityAssociation.setCredential(pc.getPassword());
            log.info("Principal and Credential set");
         }
      }

   }

}
